SystemOrganization addCategory: #'PN-PasswordCrypt'!

TestCase subclass: #PCPasswordCryptTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PN-PasswordCrypt'!

!PCPasswordCryptTests commentStamp: '<historical>' prior: 0!
Tests for PCPasswordCrypt.
!

!PCPasswordCryptTests methodsFor: 'testing' stamp: 'PierceNg 11/17/2013 15:24'!
test256

	self assert: (PCPasswordCrypt sha256Crypt: 'Hello world!!' withSalt: 'saltstring')
		equals: '$5$saltstring$5B8vYYiY.CVt1RlTTf8KbXBH3hsxY/GNooZaBBGWEc5' ! !

!PCPasswordCryptTests methodsFor: 'testing' stamp: 'PierceNg 11/17/2013 15:25'!
test512

	self assert: (PCPasswordCrypt sha512Crypt: 'Hello world!!' withSalt: 'saltstring')
		equals: '$6$saltstring$svn8UoSVapNtMuq1ukKS4tPQd8iKwSMHWjl/O817G3uBnIFNjnQJuesI68u4OTLiBFdcbYEdFCoEOfaS35inz1' ! !

Object subclass: #PCPasswordCrypt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PN-PasswordCrypt'!

!PCPasswordCrypt commentStamp: '<historical>' prior: 0!
I provide secure password hashing based on SHA-256/512.
!

!PCPasswordCrypt class methodsFor: 'utilities' stamp: 'PierceNg 11/17/2013 15:11'!
sha256Crypt: aString withSalt: aSaltString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
		
	^ self nbCall: #(String sha256_crypt (String aString, String aSaltString)) 
		module: #shacrypt! !

!PCPasswordCrypt class methodsFor: 'utilities' stamp: 'PierceNg 11/17/2013 15:11'!
sha512Crypt: aString withSalt: aSaltString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
		
	^ self nbCall: #(String sha512_crypt (String aString, String aSaltString)) 
		module: #shacrypt! !
